/**
 * @function doSignin
 * @returns Promise
 */

"use strict";

const doSignget = require('./do_signget');

function doSignin(UserSign, data, digest) {
    return UserSign
        .findOne({
            where: {sign_key: data.sign_key}
        })
        .then(sign => {
            if (!sign) {
                return null;
            }
            return digest(data.password, sign.password_salt)
                .then(hash => sign && (sign.password_hash === hash))
                .then(valid => {
                    if (!valid) {
                        return null;
                    }
                    return sign
                        .update({
                            signin_at: new Date()
                        })
                        .then(sign => doSignget(UserSign, sign))
                });
        });
}


module.exports = doSignin;

