/**
 * @function doSignmod
 * @returns Promise
 */

"use strict";

const doSignget = require('./do_signget');

/** @lends doSignmod */
function doSignmod(UserSign, data, digest, signed) {
    const User = UserSign.getRef('user').model;
    let userId = signed.user.id;
    let userPatch = Object.assign({}, data);
    delete userPatch.password;
    return User
        .findById(userId, {
            include: [User.getRef('sign')]
        })
        .then(user =>
            user.update(userPatch)
        )
        .then(user =>
            UserSign.findAll({
                where: {user_id: userId}
            }).then(signs =>
                signs.map(sign =>
                    digest(data.password || sign.password, sign.password_salt)
                        .then(hash =>
                            sign.update({
                                sign_key: user.get(sign.sign_key_kind),
                                password_hash: hash,
                                signmod_at: new Date()
                            })
                        )
                )
            )
        )
        .then(user =>
            doSignget(UserSign, signed)
        )

}

module.exports = doSignmod;

